<template>
  <!--
  Principes de fonctionnement
  On parse un fichier de config JSON. A chaque entrée un type est défini
  Suivant le type un input est généré
  -->
  <v-flex md12>
    <v-dialog v-model="dialogLoader" persistent max-width="400">
      <v-progress-linear :indeterminate="true"></v-progress-linear>
    </v-dialog>
    <v-layout v-for="(conf, indexI) in configInject" :key="indexI" row wrap>
      <v-flex md12 xs12>
        <v-layout
          v-for="(contentConfig, indexJ) in conf.contenu"
          :key="indexJ"
          class="text-xs-left"
        >
          <v-layout v-if="contentConfig.type == 'boolean'">
            <v-flex md3 xs6>{{ contentConfig.libelle }}</v-flex>

            <v-flex md9 xs6>
              <v-radio-group row v-model="contentConfig.value">
                <v-radio label="Oui" :value="true"></v-radio>
                <v-radio label="Non" :value="false"></v-radio>
              </v-radio-group>
            </v-flex>
          </v-layout>

          <v-layout v-if="contentConfig.type == 'titre'">
            <v-text-field v-model="contentConfig.value" :label="contentConfig.libelle"></v-text-field>
          </v-layout>

          <v-layout v-if="contentConfig.type == 'number'">
            <v-text-field
              v-model="contentConfig.value"
              type="number"
              :label="contentConfig.libelle"
            ></v-text-field>
          </v-layout>

          <v-layout v-if="contentConfig.type == 'text'" my-2>
            <v-flex>
              <!-- Textarea sans editeur -->

              <!--
                <v-textarea
                v-model="contentConfig.value"
                box
                :label="contentConfig.libelle"
                :value="contentConfig.value"
              ></v-textarea>
              -->

              <!-- Textarea avec editeur -->
              <span>{{ contentConfig.libelle }}</span>
              <v-card style="overflow:hidden">
                <v-card-text>
                  <wysiwyg v-model="contentConfig.value" placeholder />
                </v-card-text>
              </v-card>
            </v-flex>
          </v-layout>

          <v-layout v-if="contentConfig.type == 'email'">
            <v-text-field v-model="contentConfig.value" type="email" :label="contentConfig.libelle"></v-text-field>
          </v-layout>

          <v-layout v-if="contentConfig.type == 'file'">
            <v-layout row wrap>
              <v-flex md2 xs12>{{ contentConfig.libelle }}</v-flex>

              <v-flex md7 xs8>
                <v-btn fab dark small color="red" v-if="contentConfig.value">
                  <v-icon dark @click="deleteMedia(contentConfig.value, indexI, indexJ)">delete</v-icon>
                </v-btn>

                <input v-else type="file" :ref="'fileInput' + contentConfig.id" />

                <input
                  type="text"
                  :ref="'fileValue' + contentConfig.id"
                  readonly
                  v-model="contentConfig.value"
                />
              </v-flex>

              <v-flex md3 xs4>
                <v-btn
                  color="primary"
                  @click.stop="onUploadSelectedFileClick(contentConfig.id, indexI, indexJ)"
                >UPLOAD</v-btn>
              </v-flex>
            </v-layout>
          </v-layout>
        </v-layout>
      </v-flex>
    </v-layout>
    <v-layout>
      <v-flex md6 xs12>
        <v-btn @click="saveDataConfig()" large color="primary">Mettre à jour la config</v-btn>
      </v-flex>
      <v-flex md6 xs12>
        <v-btn @click="resetToDefault()" large color="warning">Configuration par défaut</v-btn>
      </v-flex>
    </v-layout>
    <v-snackbar color="red" top v-model="snackbar.actif" :multi-line="snackbar.multiLine">
      {{ snackbar.text }}
      <v-btn color="primary" text @click="snackbar.actif = false">Fermer</v-btn>
    </v-snackbar>
  </v-flex>
</template>

<script>
// import axios from "axios";
import { getHeader } from "@/config";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_CREATE_CONFIG = URL_API + "api/config/create/";
const URL_UPDATE_CONFIG = URL_API + "api/config/edit/";
const URL_UPLOAD_CONFIG = URL_API + "api/upload-file";
const URL_API_DELETEIMAGES_CONFIG_FTP = URL_API + "api/images/delete-on-ftp";

export default {
  props: ["initialConfig", "configInject", "configName", "initConfig"],
  data() {
    return {
      dialogLoader: false,

      infoConfig: [],
      itemsActif: [
        {
          text: "Oui",
          value: true,
        },
        {
          text: "Non",
          value: false,
        },
      ],
      // Snackbar
      snackbar: {
        actif: false,
        multiline: true,
        text: "",
      },
    };
  },
  methods: {
    onUploadSelectedFileClick(idData, idceI, idceJ) {
      let fileInputRef = "fileInput" + idData;
      let fileValueRef = "fileValue" + idData;
      let fileToUpload = this.$refs[fileInputRef][0].files[0];

      if (fileToUpload == undefined || fileToUpload == "") {
        this.snackbar.text = "Veuillez uploader un média valide";
        this.snackbar.actif = true;
        this.dialogLoader = false;
        return false;
      }

      self = this;
      this.dialogLoader = true;

      let formData = new FormData();
      formData.append("file", fileToUpload);
      formData.append("aliasFolder", process.env.VUE_APP_SITE_ALIAS);

      this.$axios
        .post(URL_UPLOAD_CONFIG, formData, {
          headers: {
            "Content-Type": "multipart/form-data",
          },
        })
        .then((response) => {
          this.$refs[fileValueRef][0].value = response.data.imgName;
          this.configInject[idceI].contenu[idceJ].value = response.data.imgName;
        })
        .catch((error) => {
          console.log("error", error);
        })
        .then(function () {
          self.dialogLoader = false;
        });
    },
    deleteMedia(valueData, idceI, idceJ) {
      self = this;
      this.dialogLoader = true;
      let payload = {
        name: valueData,
        isConfig: true,
        aliasFolder: process.env.VUE_APP_SITE_ALIAS,
      };
      this.$axios
        .post(URL_API_DELETEIMAGES_CONFIG_FTP, payload)
        .then((response) => {
          self.configInject[idceI].contenu[idceJ].value = "";
          self.saveDataConfig();
          self.snackbar.text = "Image supprimé";
          self.snackbar.actif = true;
          self.dialogLoader = false;
        })
        .catch((error) => {
          console.log("error = ", error);
          this.isLoading = false;
        });
    },
    saveDataConfig() {
      let payload = {
        data: this.configInject,
      };
      let urlAction = URL_UPDATE_CONFIG + this.configName;
      this.updateConfig(urlAction, payload);
    },
    resetToDefault() {
      let payload = {
        data: this.initialConfig[this.configName],
      };
      let urlAction = URL_UPDATE_CONFIG + this.configName;
      this.updateConfig(urlAction, payload);
    },
    updateConfig(urlAction, payload) {
      this.$axios
        .put(urlAction, payload, { headers: getHeader() })
        .then((response) => {
          this.snackbar.text = "Configuration modifié";
          this.snackbar.actif = true;
          // this.$router.push({ name: "admin-config-site" });
          location.reload();
        })
        .catch((error) => {
          console.log("error", error);
        });
    },
  },
};
</script>

<style></style>
